<?php

// +---------------------------------------------------------------------------+
// | MyCal 3.0 for Geeklog - The Ultimate Weblog                               |
// +---------------------------------------------------------------------------+
// | install.php                                                               |
// |                                                                           |
// | This file installs and removes the data structures for the MyCal          |
// | plugin for Geeklog.                                                       |
// |                                                                           |
// | Simply put here is what this install does:                                |
// | 1) It adds the mycal block to the blocks table                            |
// | 2) It adds the plugin to the plugins table                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004-2005 by the following authors:                         |
// |                                                                           |
// | Author:                                                                   |
// | Marcello Teodori            -    magomarcelo@gmail.com                    |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_CONF['path'] . 'plugins/mycal/functions.inc');

$pi_name = 'mycal';                  // Plugin name  Must be 15 chars or less
$pi_version = $_MC_CONF['version'];     // Plugin Version
$gl_version = '1.3.11';                 // GL Version plugin for
$pi_url = 'http://www.geeklog.net';     // Plugin Homepage

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the mycal install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_MC00['access_denied']);
    $display .= $LANG_MC00['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Puts the datastructures for this plugin into the Geeklog database
*
* Note: Corresponding uninstall routine is in functions.inc
* 
* @return   boolean True if successful False otherwise
*
*/
function plugin_install_mycal() {
    global $pi_name, $pi_version, $gl_version, $pi_url, $DEFVALUES, $LANG_MC01;
    global $_TABLES;

    COM_errorLog("Attempting to install the $pi_name Plugin",1);

    // Add the mycal block
    $DEFVALUES['blocks'] = "INSERT INTO " . $_TABLES['blocks'] . "(is_enabled,name,type,title,tid,blockorder,onleft,phpblockfn,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon) "
     . " VALUES ('1','".$LANG_MC01['plugin_name']."','phpblock','".$LANG_MC01['plugin_title']."','homeonly',0,0,'phpblock_mycal_calendar',4,2,3,2,2,2)";

    foreach ($DEFVALUES as $table => $sql) {
        COM_errorLog("Inserting default data into $table table: $sql",1);
        DB_query($sql,1);
        if (DB_error()) {
            COM_errorLog("Error inserting default data into $table table",1);
            plugin_uninstall_mycal();
            return false;
            exit;
        }
        COM_errorLog("Success - inserting data into $table table",1);
    }

    // Register the plugin with Geeklog
    COM_errorLog("Registering $pi_name plugin with Geeklog", 1);
    DB_delete($_TABLES['plugins'],'pi_name','mycal');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('$pi_name', '$pi_version', '$gl_version', '$pi_url', 1)");

    if (DB_error()) {
        plugin_uninstall_mycal();
        return false;
        exit;
    }

    COM_errorLog("Succesfully installed the $pi_name Plugin!",1);
    return true;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/mycal/templates');
$T->set_file('install', 'install.thtml');
$T->set_var('install_header', $LANG_MC00['install_header']);
$T->set_var('img',$_CONF['site_url'] . '/mycal/images/mycal.gif');
$T->set_var('cgiurl', $_CONF['site_admin_url'] . '/plugins/mycal/install.php');

if ($action == 'install') {
    if (plugin_install_mycal()) {
        $T->set_var('installmsg1',$LANG_MC00['install_success']);
    } else {
        $T->set_var('installmsg1',$LANG_MC00['install_failed']);
    }
} else if ($action == "uninstall") {
   plugin_uninstall_mycal();
   $T->set_var('installmsg1',$LANG_MC00['uninstall_msg']);
}

if (DB_count($_TABLES['plugins'], 'pi_name', 'mycal') == 0) {
    $T->set_var('installmsg2', $LANG_MC00['uninstalled']);
    $T->set_var('readme', $LANG_MC00['readme']);
    $T->set_var('installdoc', $LANG_MC00['installdoc']);
	$T->set_var('btnmsg', $LANG_MC00['install']);
	$T->set_var('action','install');
} else {
    $T->set_var('installmsg2', $LANG_MC00['installed']);
	$T->set_var('btnmsg', $LANG_MC00['uninstall']);
	$T->set_var('action','uninstall');
}
$T->parse('output','install');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;

?>
