<?php
//
// +---------------------------------------------------------------------------+
// | MyCal Plugin 3.0 for Geeklog - The Ultimate Weblog                        |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things:                                                |
// | 1) it implements the necessary Geeklog Plugin API method                  |
// | 2) implements all the common code needed by the mycal PHP files.          |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000-2005 by the following authors:                         |
// |                                                                           |
// | Author:                                                                   |
// | Marcello Teodori            -    magomarcelo@gmail.com                    |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | Original PHP Calendar by Scott Richardson - srichardson@scanonline.com    |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//



/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/mycal/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile)) {
    include_once ($langfile);
} else {
    include_once ($_CONF['path'] . 'plugins/mycal/language/english.php');
}

/*
* Include mycal config file
*/
require_once ($_CONF['path'] . 'plugins/mycal/config.php');


function display_calendar() {
    global $HTTP_POST_VARS,$_TABLES,$_CONF,$LANG_MC02;
    
    setlocale(LC_TIME, "");
    if( !isset($HTTP_POST_VARS['month']) ) {
        $WorkDate = date("m/d/Y");
    }
    else{
        $WorkDate = $HTTP_POST_VARS['month'];
        $GLOBALS['WorkDate'] = $WorkDate;
    }
    $PrevMonth = date("m/d/Y", strtotime($WorkDate . "-1 month"));
    $NextMonth = date("m/d/Y", strtotime($WorkDate . "+1 month"));
    $Today = date("j", strtotime($WorkDate));
    $DaysThisMonth = mycalDaysInMonth(date("m/d/Y",strtotime($WorkDate)));
    $DaysLastMonth = mycalDaysInMonth(date("m/d/Y", strtotime ($PrevMonth)));
    
    $GLOBALS['InThisMonth'] = -1;
    $CurrentDay = GetStartingPoint($DaysLastMonth);

    //Header with Month Title and Next/Prev buttons
    $loc = $PHP_SELF;

    $BlockDisplay .= "<form name='prev_month_form' method='post' action='$loc'>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$PrevMonth'>";
    $BlockDisplay .= "</form>";

    $BlockDisplay .= "<form name='next_month_form' method='post' action='$loc'>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$NextMonth'>";
    $BlockDisplay .= "</form>";

    $BlockDisplay .= "<table width='100%' cellspacing='0' border='0'>";

    $BlockDisplay .= "<tr class='mycalTopTitle'><td colspan='7' height='8%' align='center' >";

    // [magomarcelo] moved buttons at top and transformed into links    
    $BlockDisplay .= "<table height='100%' cellspacing='0' cellpadding='0' width='100%' border='0'>";
    $BlockDisplay .= "<tr>"; 

    $BlockDisplay .= "<td align='center'>";
    $BlockDisplay .= "<font size='1'><a href='javascript:document.prev_month_form.submit()'>&lt;&lt;</a></font>";
    $BlockDisplay .= "</td>";

    $BlockDisplay .= "<td align='center'>";
    $BlockDisplay .= "<font size='1'><b>".ucfirst(strftime("%B %Y", strtotime($WorkDate)))."</b></font>";
    $BlockDisplay .= "</td>";

    $BlockDisplay .= "<td align='center'>";
    $BlockDisplay .= "<font size='1'><a href='javascript:document.next_month_form.submit()'>&gt;&gt;</a></font>";
    $BlockDisplay .= "</td>";

    $BlockDisplay .= "</tr>";
    $BlockDisplay .= "</table>";

    $BlockDisplay .= "</td></tr>";

    // Main Calendar
    $BlockDisplay .= "<tr class='mycalTitle'>";
    $BlockDisplay .= "<td height='8%' align='center' valign='top' width='15%' class='mycalTitle'><font size='1'><b>".$LANG_MC02['sunday_short']."</b></font></td>";
    $BlockDisplay .= "<td align='center' valign='top' width='14%' ><font size='1'><b>".$LANG_MC02['monday_short']."</b></font></td>";
    $BlockDisplay .= "<td align='center' valign='top' width='14%' ><font size='1'><b>".$LANG_MC02['tuesday_short']."</b></font></td>";
    $BlockDisplay .= "<td align='center' valign='top' width='14%' ><font size='1'><b>".$LANG_MC02['wednesday_short']."</b></font></td>";
    $BlockDisplay .= "<td align='center' valign='top' width='14%' ><font size='1'><b>".$LANG_MC02['thursday_short']."</b></font></td>";
    $BlockDisplay .= "<td align='center' valign='top' width='14%' ><font size='1'><b>".$LANG_MC02['friday_short']."</b></font></td>";
    $BlockDisplay .= "<td align='center' valign='top' width='15%' ><font size='1'><b>".$LANG_MC02['saturday_short']."</b></font></td>";
    $BlockDisplay .= "</tr>";
    
    
    for($x = 1; $x < 7; $x++) {
        $BlockDisplay .= "<tr>";
        for($i=1;$i<8;$i++){
            $BlockDisplay .= "<td align='left' valign='top' height='14%' ";

            $event_url = mycal_eventurl($WorkDate, $CurrentDay, $GLOBALS['InThisMonth']);
            $BlockDisplay .= $event_url;
            $CurrentDay++;
                        
            $BlockDisplay .= "</center></td>";

            if( $GLOBALS['InThisMonth'] == -1 && $CurrentDay > $DaysLastMonth ){
                $CurrentDay = 1;
                $GLOBALS['InThisMonth'] = 0;
            }
            elseif($GLOBALS['InThisMonth'] == 0 && $CurrentDay > $DaysThisMonth ){
                $CurrentDay = 1;
                $GLOBALS['InThisMonth'] = 1;
            }
        }

        $BlockDisplay .= "</tr>";
        // Check to see if I need to display another week
        if ($GLOBALS['InThisMonth']==1) {
            break;
        }
    }

    $BlockDisplay .= "</table>";
/*
    $BlockDisplay .= "<table width='100%' border='0'><tr>";
    $BlockDisplay .= "<td>";    
    $BlockDisplay .= "<form method='post' action='$loc' >";
    $BlockDisplay .= "<input type='submit' value=' < '>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$PrevMonth'>";
    $BlockDisplay .= "</form></td>";
    $BlockDisplay .= "<td align='center'><font size='-2'>".$LANG_MC03['clickondate']."</font></td>";
    $BlockDisplay .= "<td>";    
    $BlockDisplay .= "<form align='right' method='post' action='$loc' >";
    $BlockDisplay .= "<input type='submit' value=' > '>";
    $BlockDisplay .= "<input type='hidden' name='month' value='$NextMonth'>";
    $BlockDisplay .= "</form></td>";
    $BlockDisplay .= "</table>";
*/

    return $BlockDisplay;

}

function mycalDaysInMonth($dt) {
    return date("t",strtotime($dt));
}

function GetStartingPoint($DLM){
    global $InthisMonth;
    $today = getdate(strtotime($GLOBALS['WorkDate']));
    $mday = $today['mday'];
    $mday-=1;
    $FirstOfMonth = date("m/d/Y",strtotime($GLOBALS['WorkDate'] . "-" . $mday . " days"));

    // Determine which day of the week the first day of this month starts on
    switch(date("l",strtotime($FirstOfMonth))){
    case "Sunday":
        $CD = 1;
        $GLOBALS['InThisMonth'] = 0;
        break;

    case "Monday":
        $CD = $DLM;
        break;

    case "Tuesday":
        $CD = $DLM-1;
        break;

    case "Wednesday":
        $CD = $DLM-2;
        break;

    case "Thursday":
        $CD = $DLM-3;
        break;

    case "Friday":
        $CD = $DLM-4;
        break;

    case "Saturday":
        $CD = $DLM-5;
    }

    return $CD;
}

function GetThisDate($SelectedDay){
    $today = getdate(strtotime($GLOBALS['WorkDate']));
    $mon = $today['mon'];
    $myear = $today['year'];
    return date("m/d/Y", strtotime($mon."/".$SelectedDay."/".$myear));
}
    
// support date format as : 23 1 2003, 23-01-2003, 23/01/2003, 
// return timestamp
function mycal_eventurl($WorkDate, $CurrentDay, $nextmonth='0'){
    global $_TABLES,$_CONF;

    $HighlightToday = false;
    $SecondsSinceEpoch = strtotime($WorkDate);

    $eventyear = date("Y", $SecondsSinceEpoch);
    $eventmonth = date("n", $SecondsSinceEpoch) + $nextmonth;
    if ($eventmonth>12) {
        $eventmonth=1;
        $eventyear++;
    } elseif ($eventmonth<1) {
        $eventmonth=12;
        $eventyear--;
    }

    $eventchk_date = $eventyear ."-".$eventmonth."-". $CurrentDay;
    $eventday = $CurrentDay++;

    if (date("m/Y") == date("m/Y", $SecondsSinceEpoch) && $eventday==date("d")) {
        $HighlightToday = true;
    }
        
    $eventSql = "SELECT eid, title,url,datestart,dateend,group_id,owner_id,perm_owner,perm_group,perm_members,perm_anon  FROM {$_TABLES['events']} WHERE datestart = '$eventchk_date'";
    $result = DB_query($eventSql);
    $theEvent= DB_fetchArray($result);

    if ((DB_numrows($result) > 0) && 
        (SEC_hasAccess($theEvent['owner_id'],$theEvent['group_id'],$theEvent['perm_owner'],$theEvent['perm_group'],$theEvent['perm_members'],$theEvent['perm_anon']) > 0)) {
            $event_title = $theEvent['title'];
            if ($HighlightToday){
                $class="mycalTodayHighlight";
            }else{
                $class="mycalEventHighlight";
            }
            $event_url .= 'class="'.$class.'"><center><a class="mycallink" href="' .$_CONF["site_url"] .'/mycal/calsearch.php?datestart='.$eventchk_date.'&dateend='.$eventchk_date.'&type=all&mode=search" TITLE="'.$event_title.'"><b>'.$eventday.'</b></a>';
            return $event_url;    
    } else {
        if ($nextmonth != 0) {
            $event_url = 'class="mycalNextMonth"><center><a class="mycallink" href="' .$_CONF["site_url"] .'/mycal/calsearch.php?datestart='.$eventchk_date.'&dateend='.$eventchk_date.'&type=all&mode=search">'.$eventday.'</a>';
        } else {
            if ($HighlightToday){
                $class="mycalTodayHighlight";
            }else{
                $class="mycalDateField";
            }
            $event_url .='class="'.$class.'"><center><a class="mycallink" href="' .$_CONF["site_url"] .'/mycal/calsearch.php?datestart='.$eventchk_date.'&dateend='.$eventchk_date.'&type=all&mode=search"><b>'.$eventday.'</b></a>';
        }
        return $event_url;
    }
}


// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_mycal($installCheck='') {
    global $_TABLES, $LANG_MC00, $_MC_TABLES, $_MC_CONF;

    $pi_name='mycal';
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
	    COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
		$display .= COM_startBlock($LANG_MC00['warning']);
		$display .= $LANG_MC00['enabled'];
		$display .= COM_endBlock();
		echo $display;
		return false;
		exit;
	}
    	
    // Ok to proceed and delete plugin

    // Delete block
    COM_errorLog("Removing MyCal - Block Definition ", 1);
    DB_query("DELETE FROM {$_TABLES['blocks']} WHERE phpblockfn = 'phpblock_mycal_calendar'",1);

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the mycal plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'mycal'",1);

    COM_errorLog('...success', 1);
    return true;
}


/**
* This function is called from COM_siteHeader and will return additional Header information
* This can be Javascript functions required for the plugin or extra Metatags
*
* @return   string      returns a concatenated string of all plugins extra header code
*/
function plugin_getheadercode_mycal() {
    global $_CONF;

    // deliver custom style sheet
    $cssfile = $_CONF['path_layout'] . 'mycal.css';

    if (file_exists ($cssfile)) {
        $retval = '<link rel="stylesheet" type="text/css" href="' . $_CONF['layout_url'] . '/mycal.css" />' . "\n";
    } else {
        $retval = '<link rel="stylesheet" type="text/css" href="' . $_CONF['site_url'] . '/mycal/style.css" />' . "\n";
    }


    return $retval;
}


/**
 * Returns the current plugin code version
 *
 * @return string    plugin version
 */
function plugin_chkVersion_mycal() {
    return $_MC_CONF['version'];
}

/**
* Blaine Lang July 19/03  www.langfamily.ca
* This Geeklog PHP function displays a formated monthly calendar in a block
* It is integrated into the site search feature to allow users to click on a date and
* retrieve all postings and updates for that date.
* Also hightlights dates with calendar events.
* Creates tool-tip title when user has cursor over date with a highlighted calendar event - displays event description
**/
function phpblock_mycal_calendar() {
   global $_CONF;
   $retval = display_calendar();
   return $retval;
}

?>
